Index: /palm/trunk/SOURCE/module_interface.f90
===================================================================
--- /palm/trunk/SOURCE/module_interface.f90	(revision 4752)
+++ /palm/trunk/SOURCE/module_interface.f90	(revision 4753)
@@ -216,372 +211,372 @@
 !-- load module-specific control parameters.
 !-- ToDo: move all of them to respective module or a dedicated central module
-    USE data_output_module,                                                    &
-        ONLY:  dom_def_end,                                                    &
-               dom_finalize_output,                                            &
+    USE data_output_module,                                                                        &
+        ONLY:  dom_def_end,                                                                        &
+               dom_finalize_output,                                                                &
                dom_init
 
-    USE dynamics_mod, &
-        ONLY:  dynamics_parin, &
-               dynamics_check_parameters, &
-               dynamics_check_data_output_ts, &
-               dynamics_check_data_output_pr, &
-               dynamics_check_data_output, &
-               dynamics_init_masks, &
-               dynamics_define_netcdf_grid, &
-               dynamics_init_arrays, &
-               dynamics_init, &
-               dynamics_init_checks, &
-               dynamics_header, &
-               dynamics_actions, &
-               dynamics_non_advective_processes, &
-               dynamics_exchange_horiz, &
-               dynamics_prognostic_equations, &
-               dynamics_boundary_conditions, &
-               dynamics_swap_timelevel, &
-               dynamics_3d_data_averaging, &
-               dynamics_data_output_2d, &
-               dynamics_data_output_3d, &
-               dynamics_statistics, &
-               dynamics_rrd_global, &
-               dynamics_rrd_local, &
-               dynamics_wrd_global, &
-               dynamics_wrd_local, &
-               dynamics_last_actions
-
-    USE turbulence_closure_mod, &
-        ONLY:  tcm_check_parameters, &
-               tcm_check_data_output, &
-               tcm_init_arrays, &
-               tcm_init, &
-               tcm_actions, &
-               tcm_prognostic_equations, &
-               tcm_boundary_conds, &
-               tcm_swap_timelevel, &
-               tcm_3d_data_averaging, &
-               tcm_data_output_2d, &
-               tcm_data_output_3d
-
-    USE control_parameters,                                                    &
-        ONLY:  air_chemistry,                                                  &
-               biometeorology,                                                 &
-               coupling_char,                                                  &
-               debug_output,                                                   &
-               debug_output_timestep,                                          &
-               indoor_model,                                                   &
-               land_surface,                                                   &
-               large_scale_forcing,                                            &
-               nesting_offline,                                                &
-               nudging,                                                        &
-               ocean_mode,                                                     &
-               plant_canopy,                                                   &
-               salsa,                                                          &
-               surface_output,                                                 &
-               syn_turb_gen,                                                   &
-               urban_surface,                                                  &
-               vdi_checks,                                                     &
-               virtual_flight,                                                 &
-               virtual_measurement,                                            &
+    USE dynamics_mod,                                                                              &
+        ONLY:  dynamics_3d_data_averaging,                                                         &
+               dynamics_actions,                                                                   &
+               dynamics_boundary_conditions,                                                       &
+               dynamics_check_data_output,                                                         &
+               dynamics_check_data_output_pr,                                                      &
+               dynamics_check_data_output_ts,                                                      &
+               dynamics_check_parameters,                                                          &
+               dynamics_data_output_2d,                                                            &
+               dynamics_data_output_3d,                                                            &
+               dynamics_define_netcdf_grid,                                                        &
+               dynamics_exchange_horiz,                                                            &
+               dynamics_header,                                                                    &
+               dynamics_init,                                                                      &
+               dynamics_init_arrays,                                                               &
+               dynamics_init_checks,                                                               &
+               dynamics_init_masks,                                                                &
+               dynamics_last_actions,                                                              &
+               dynamics_non_advective_processes,                                                   &
+               dynamics_parin,                                                                     &
+               dynamics_prognostic_equations,                                                      &
+               dynamics_rrd_global,                                                                &
+               dynamics_rrd_local,                                                                 &
+               dynamics_statistics,                                                                &
+               dynamics_swap_timelevel,                                                            &
+               dynamics_wrd_global,                                                                &
+               dynamics_wrd_local
+
+    USE turbulence_closure_mod,                                                                    &
+        ONLY:  tcm_3d_data_averaging,                                                              &
+               tcm_actions,                                                                        &
+               tcm_boundary_conds,                                                                 &
+               tcm_check_data_output,                                                              &
+               tcm_check_parameters,                                                               &
+               tcm_data_output_2d,                                                                 &
+               tcm_data_output_3d,                                                                 &
+               tcm_init,                                                                           &
+               tcm_init_arrays,                                                                    &
+               tcm_prognostic_equations,                                                           &
+               tcm_swap_timelevel
+
+    USE control_parameters,                                                                        &
+        ONLY:  air_chemistry,                                                                      &
+               biometeorology,                                                                     &
+               coupling_char,                                                                      &
+               debug_output,                                                                       &
+               debug_output_timestep,                                                              &
+               indoor_model,                                                                       &
+               land_surface,                                                                       &
+               large_scale_forcing,                                                                &
+               nesting_offline,                                                                    &
+               nudging,                                                                            &
+               ocean_mode,                                                                         &
+               plant_canopy,                                                                       &
+               salsa,                                                                              &
+               surface_output,                                                                     &
+               syn_turb_gen,                                                                       &
+               urban_surface,                                                                      &
+               vdi_checks,                                                                         &
+               virtual_flight,                                                                     &
+               virtual_measurement,                                                                &
                wind_turbine
 
 !
-!-- load interface routines of all PALM modules
-    USE biometeorology_mod,                                                    &
-        ONLY:  bio_parin,                                                      &
-               bio_check_data_output,                                          &
-               bio_init,                                                       &
-               bio_init_checks,                                                &
-               bio_header,                                                     &
-               bio_3d_data_averaging,                                          &
-               bio_data_output_2d,                                             &
-               bio_data_output_3d,                                             &
-               bio_rrd_global,                                                 &
-               bio_rrd_local,                                                  &
-               bio_wrd_global,                                                 &
+!-- Load interface routines of all PALM modules
+    USE biometeorology_mod,                                                                        &
+        ONLY:  bio_3d_data_averaging,                                                              &
+               bio_check_data_output,                                                              &
+               bio_data_output_2d,                                                                 &
+               bio_data_output_3d,                                                                 &
+               bio_init,                                                                           &
+               bio_init_checks,                                                                    &
+               bio_header,                                                                         &
+               bio_parin,                                                                          &
+               bio_rrd_global,                                                                     &
+               bio_rrd_local,                                                                      &
+               bio_wrd_global,                                                                     &
                bio_wrd_local
 
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model,                                               &
-               bcm_parin,                                                      &
-               bcm_check_parameters,                                           &
-               bcm_check_data_output_pr,                                       &
-               bcm_check_data_output,                                          &
-               bcm_init_arrays,                                                &
-               bcm_init,                                                       &
-               bcm_header,                                                     &
-               bcm_actions,                                                    &
-               bcm_non_advective_processes,                                    &
-               bcm_exchange_horiz,                                             &
-               bcm_prognostic_equations,                                       &
-               bcm_boundary_conditions,                                        &
-               bcm_swap_timelevel,                                             &
-               bcm_3d_data_averaging,                                          &
-               bcm_data_output_2d,                                             &
-               bcm_data_output_3d,                                             &
-               bcm_rrd_global,                                                 &
-               bcm_wrd_global,                                                 &
-               bcm_rrd_local,                                                  &
-               bcm_wrd_local
-
-   USE chemistry_model_mod,                                                    &
-       ONLY:  chem_parin,                                                      &
-              chem_check_parameters,                                           &
-              chem_check_data_output_pr,                                       &
-              chem_check_data_output,                                          &
-              chem_exchange_horiz_bounds,                                      &
-              chem_init_arrays,                                                &
-              chem_init,                                                       &
-              chem_header,                                                     &
-              chem_actions,                                                    &
-              chem_non_advective_processes,                                    &
-              chem_prognostic_equations,                                       &
-              chem_boundary_conditions,                                        &
-              chem_swap_timelevel,                                             &
-              chem_3d_data_averaging,                                          &
-              chem_data_output_2d,                                             &
-              chem_data_output_3d,                                             &
-              chem_statistics,                                                 &
-              chem_rrd_local,                                                  &
+    USE bulk_cloud_model_mod,                                                                      &
+        ONLY:  bcm_3d_data_averaging,                                                              &
+               bcm_actions,                                                                        &
+               bcm_boundary_conditions,                                                            &
+               bcm_check_data_output_pr,                                                           &
+               bcm_check_data_output,                                                              &
+               bcm_check_parameters,                                                               &
+               bcm_data_output_2d,                                                                 &
+               bcm_data_output_3d,                                                                 &
+               bcm_exchange_horiz,                                                                 &
+               bcm_header,                                                                         &
+               bcm_init_arrays,                                                                    &
+               bcm_init,                                                                           &
+               bcm_non_advective_processes,                                                        &
+               bcm_parin,                                                                          &
+               bcm_prognostic_equations,                                                           &
+               bcm_rrd_global,                                                                     &
+               bcm_rrd_local,                                                                      &
+               bcm_swap_timelevel,                                                                 &
+               bcm_wrd_global,                                                                     &
+               bcm_wrd_local,                                                                      &
+               bulk_cloud_model
+
+   USE chemistry_model_mod,                                                                        &
+       ONLY:  chem_3d_data_averaging,                                                              &
+              chem_actions,                                                                        &
+              chem_boundary_conditions,                                                            &
+              chem_check_data_output,                                                              &
+              chem_check_data_output_pr,                                                           &
+              chem_check_parameters,                                                               &
+              chem_data_output_2d,                                                                 &
+              chem_data_output_3d,                                                                 &
+              chem_exchange_horiz_bounds,                                                          &
+              chem_header,                                                                         &
+              chem_init,                                                                           &
+              chem_init_arrays,                                                                    &
+              chem_non_advective_processes,                                                        &
+              chem_parin,                                                                          &
+              chem_prognostic_equations,                                                           &
+              chem_rrd_local,                                                                      &
+              chem_statistics,                                                                     &
+              chem_swap_timelevel,                                                                 &
               chem_wrd_local
 
-    USE diagnostic_output_quantities_mod,                                      &
-        ONLY:  doq_3d_data_averaging,                                          &
-               doq_check_data_output,                                          &
-               doq_define_netcdf_grid,                                         &
-               doq_init,                                                       &
-               doq_output_2d,                                                  &
-               doq_output_3d,                                                  &
-               doq_rrd_local,                                                  &
+    USE diagnostic_output_quantities_mod,                                                          &
+        ONLY:  doq_3d_data_averaging,                                                              &
+               doq_check_data_output,                                                              &
+               doq_define_netcdf_grid,                                                             &
+               doq_init,                                                                           &
+               doq_output_2d,                                                                      &
+               doq_output_3d,                                                                      &
+               doq_rrd_local,                                                                      &
                doq_wrd_local
 
-    USE flight_mod,                                                            &
-        ONLY:  flight_parin,                                                   &
-               flight_header,                                                  &
-               flight_init,                                                    &
-               flight_rrd_global,                                              &
+    USE flight_mod,                                                                                &
+        ONLY:  flight_header,                                                                      &
+               flight_init,                                                                        &
+               flight_parin,                                                                       &
+               flight_rrd_global,                                                                  &
                flight_wrd_global
 
-    USE gust_mod,                                                              &
-        ONLY:  gust_module_enabled,                                            &
-               gust_parin,                                                     &
-               gust_check_parameters,                                          &
-               gust_check_data_output_pr,                                      &
-               gust_check_data_output,                                         &
-               gust_init_arrays,                                               &
-               gust_init,                                                      &
-               gust_header,                                                    &
-               gust_actions,                                                   &
-               gust_prognostic_equations,                                      &
-               gust_swap_timelevel,                                            &
-               gust_3d_data_averaging,                                         &
-               gust_data_output_2d,                                            &
-               gust_data_output_3d,                                            &
-               gust_statistics,                                                &
-               gust_rrd_global,                                                &
-               gust_wrd_global,                                                &
-               gust_rrd_local,                                                 &
+    USE gust_mod,                                                                                  &
+        ONLY:  gust_3d_data_averaging,                                                             &
+               gust_actions,                                                                       &
+               gust_check_parameters,                                                              &
+               gust_check_data_output,                                                             &
+               gust_check_data_output_pr,                                                          &
+               gust_data_output_2d,                                                                &
+               gust_data_output_3d,                                                                &
+               gust_header,                                                                        &
+               gust_init,                                                                          &
+               gust_init_arrays,                                                                   &
+               gust_module_enabled,                                                                &
+               gust_parin,                                                                         &
+               gust_prognostic_equations,                                                          &
+               gust_rrd_global,                                                                    &
+               gust_rrd_local,                                                                     &
+               gust_statistics,                                                                    &
+               gust_swap_timelevel,                                                                &
+               gust_wrd_global,                                                                    &
                gust_wrd_local
 
-    USE indoor_model_mod,                                                      &
-        ONLY:  im_parin,                                                       &
-               im_check_data_output,                                           &
-               im_check_parameters,                                            &
-               im_data_output_3d,                                              &
-               im_init
-
-    USE lagrangian_particle_model_mod,                                         &
-        ONLY:  lpm_parin,                                                      &
-               lpm_header,                                                     &
-               lpm_check_parameters,                                           &
-               lpm_exchange_horiz_bounds,                                      &
-               lpm_init_arrays,                                                &
-               lpm_init,                                                       &
-               lpm_actions,                                                    &
-               lpm_rrd_global,                                                 &
-               lpm_rrd_local,                                                  &
-               lpm_wrd_local,                                                  &
+    USE indoor_model_mod,                                                                          &
+        ONLY:  im_check_data_output,                                                               &
+               im_check_parameters,                                                                &
+               im_data_output_3d,                                                                  &
+               im_init,                                                                            &
+               im_parin
+
+    USE lagrangian_particle_model_mod,                                                             &
+        ONLY:  lpm_actions,                                                                        &
+               lpm_check_parameters,                                                               &
+               lpm_exchange_horiz_bounds,                                                          &
+               lpm_header,                                                                         &
+               lpm_init,                                                                           &
+               lpm_init_arrays,                                                                    &
+               lpm_parin,                                                                          &
+               lpm_rrd_global,                                                                     &
+               lpm_rrd_local,                                                                      &
+               lpm_wrd_local,                                                                      &
                lpm_wrd_global
 
-    USE land_surface_model_mod,                                                &
-        ONLY:  lsm_parin,                                                      &
-               lsm_check_parameters,                                           &
-               lsm_check_data_output_pr,                                       &
-               lsm_check_data_output,                                          &
-               lsm_init_arrays,                                                &
-               lsm_init,                                                       &
-               lsm_header,                                                     &
-               lsm_swap_timelevel,                                             &
-               lsm_3d_data_averaging,                                          &
-               lsm_data_output_2d,                                             &
-               lsm_rrd_local,                                                  &
+    USE land_surface_model_mod,                                                                    &
+        ONLY:  lsm_3d_data_averaging,                                                              &
+               lsm_check_parameters,                                                               &
+               lsm_check_data_output,                                                              &
+               lsm_check_data_output_pr,                                                           &
+               lsm_data_output_2d,                                                                 &
+               lsm_header,                                                                         &
+               lsm_init,                                                                           &
+               lsm_init_arrays,                                                                    &
+               lsm_parin,                                                                          &
+               lsm_rrd_local,                                                                      &
+               lsm_swap_timelevel,                                                                 &
                lsm_wrd_local
 
-    USE lsf_nudging_mod,                                                       &
-        ONLY:  lsf_nudging_check_parameters,                                   &
-               lsf_nudging_check_data_output_pr,                               &
-               lsf_init,                                                       &
-               nudge_init,                                                     &
-               lsf_nudging_header
-
-    USE multi_agent_system_mod,                                                &
+    USE lsf_nudging_mod,                                                                           &
+        ONLY:  lsf_nudging_check_parameters,                                                       &
+               lsf_nudging_check_data_output_pr,                                                   &
+               lsf_nudging_header,                                                                 &
+               lsf_init,                                                                           &
+               nudge_init
+
+    USE multi_agent_system_mod,                                                                    &
         ONLY:  mas_parin
 
-    USE nesting_offl_mod,                                                      &
-        ONLY:  nesting_offl_parin,                                             &
-               nesting_offl_check_parameters,                                  &
-               nesting_offl_header
-
-    USE ocean_mod,                                                             &
-        ONLY:  ocean_parin,                                                    &
-               ocean_check_parameters,                                         &
-               ocean_check_data_output_pr,                                     &
-               ocean_check_data_output,                                        &
-               ocean_exchange_horiz,                                           &
-               ocean_init_arrays,                                              &
-               ocean_init,                                                     &
-               ocean_header,                                                   &
-               ocean_actions,                                                  &
-               ocean_prognostic_equations,                                     &
-               ocean_boundary_conditions,                                      &
-               ocean_swap_timelevel,                                           &
-               ocean_3d_data_averaging,                                        &
-               ocean_data_output_2d,                                           &
-               ocean_data_output_3d,                                           &
-               ocean_rrd_global,                                               &
-               ocean_wrd_global,                                               &
-               ocean_rrd_local,                                                &
+    USE nesting_offl_mod,                                                                          &
+        ONLY:  nesting_offl_check_parameters,                                                      &
+               nesting_offl_header,                                                                &
+               nesting_offl_parin
+
+    USE ocean_mod,                                                                                 &
+        ONLY:  ocean_3d_data_averaging,                                                            &
+               ocean_actions,                                                                      &
+               ocean_boundary_conditions,                                                          &
+               ocean_check_parameters,                                                             &
+               ocean_check_data_output,                                                            &
+               ocean_check_data_output_pr,                                                         &
+               ocean_data_output_2d,                                                               &
+               ocean_data_output_3d,                                                               &
+               ocean_exchange_horiz,                                                               &
+               ocean_init_arrays,                                                                  &
+               ocean_init,                                                                         &
+               ocean_header,                                                                       &
+               ocean_parin,                                                                        &
+               ocean_prognostic_equations,                                                         &
+               ocean_rrd_global,                                                                   &
+               ocean_rrd_local,                                                                    &
+               ocean_swap_timelevel,                                                               &
+               ocean_wrd_global,                                                                   &
                ocean_wrd_local
 
-    USE particle_attributes,                                                   &
+    USE particle_attributes,                                                                       &
         ONLY:  particle_advection
 
-    USE poismg_noopt_mod,                                                      &
+    USE poismg_noopt_mod,                                                                          &
         ONLY:  poismg_noopt_init
 
-    USE plant_canopy_model_mod,                                                &
-         ONLY: pcm_parin,                                                      &
-               pcm_check_parameters,                                           &
-               pcm_check_data_output,                                          &
-               pcm_init,                                                       &
-               pcm_header,                                                     &
-               pcm_3d_data_averaging,                                          &
-               pcm_data_output_3d,                                             &
-               pcm_rrd_global,                                                 &
-               pcm_rrd_local,                                                  &
-               pcm_wrd_global,                                                 &
+    USE plant_canopy_model_mod,                                                                    &
+         ONLY: pcm_3d_data_averaging,                                                              &
+               pcm_check_parameters,                                                               &
+               pcm_check_data_output,                                                              &
+               pcm_data_output_3d,                                                                 &
+               pcm_header,                                                                         &
+               pcm_init,                                                                           &
+               pcm_parin,                                                                          &
+               pcm_rrd_global,                                                                     &
+               pcm_rrd_local,                                                                      &
+               pcm_wrd_global,                                                                     &
                pcm_wrd_local
 
-    USE radiation_model_mod,                                                   &
-        ONLY:  radiation,                                                      &
-               radiation_parin,                                                &
-               radiation_check_parameters,                                     &
-               radiation_check_data_output_ts,                                 &
-               radiation_check_data_output_pr,                                 &
-               radiation_check_data_output,                                    &
-               radiation_init,                                                 &
-               radiation_header,                                               &
-               radiation_3d_data_averaging,                                    &
-               radiation_data_output_2d,                                       &
-               radiation_data_output_3d,                                       &
-               radiation_rrd_local,                                            &
+    USE radiation_model_mod,                                                                       &
+        ONLY:  radiation,                                                                          &
+               radiation_3d_data_averaging,                                                        &
+               radiation_check_parameters,                                                         &
+               radiation_check_data_output,                                                        &
+               radiation_check_data_output_pr,                                                     &
+               radiation_check_data_output_ts,                                                     &
+               radiation_data_output_2d,                                                           &
+               radiation_data_output_3d,                                                           &
+               radiation_header,                                                                   &
+               radiation_init,                                                                     &
+               radiation_parin,                                                                    &
+               radiation_rrd_local,                                                                &
                radiation_wrd_local
 
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_parin,                                                    &
-               salsa_check_parameters,                                         &
-               salsa_check_data_output_pr,                                     &
-               salsa_check_data_output,                                        &
-               salsa_init_arrays,                                              &
-               salsa_init,                                                     &
-               salsa_header,                                                   &
-               salsa_actions,                                                  &
-               salsa_non_advective_processes,                                  &
-               salsa_exchange_horiz_bounds,                                    &
-               salsa_prognostic_equations,                                     &
-               salsa_boundary_conditions,                                      &
-               salsa_swap_timelevel,                                           &
-               salsa_3d_data_averaging,                                        &
-               salsa_data_output_2d,                                           &
-               salsa_data_output_3d,                                           &
-               salsa_statistics,                                               &
-               salsa_rrd_global,                                               &
-               salsa_rrd_local,                                                &
-               salsa_wrd_global,                                               &
+    USE salsa_mod,                                                                                 &
+        ONLY:  salsa_3d_data_averaging,                                                            &
+               salsa_actions,                                                                      &
+               salsa_boundary_conditions,                                                          &
+               salsa_check_data_output,                                                            &
+               salsa_check_data_output_pr,                                                         &
+               salsa_check_parameters,                                                             &
+               salsa_data_output_2d,                                                               &
+               salsa_data_output_3d,                                                               &
+               salsa_exchange_horiz_bounds,                                                        &
+               salsa_header,                                                                       &
+               salsa_init,                                                                         &
+               salsa_init_arrays,                                                                  &
+               salsa_non_advective_processes,                                                      &
+               salsa_parin,                                                                        &
+               salsa_prognostic_equations,                                                         &
+               salsa_rrd_global,                                                                   &
+               salsa_rrd_local,                                                                    &
+               salsa_statistics,                                                                   &
+               salsa_swap_timelevel,                                                               &
+               salsa_wrd_global,                                                                   &
                salsa_wrd_local
 
-    USE spectra_mod,                                                           &
-        ONLY:  calculate_spectra,                                              &
-               spectra_parin,                                                  &
-               spectra_check_parameters,                                       &
-               spectra_header
-
-    USE surface_data_output_mod,                                               &
-        ONLY:  surface_data_output_parin,                                      &
-               surface_data_output_check_parameters,                           &
-               surface_data_output_init_arrays,                                &
-               surface_data_output_rrd_local,                                  &
-               surface_data_output_rrd_global,                                 &
-               surface_data_output_wrd_local,                                  &
-               surface_data_output_wrd_global
-
-    USE surface_mod,                                                           &
+    USE spectra_mod,                                                                               &
+        ONLY:  calculate_spectra,                                                                  &
+               spectra_check_parameters,                                                           &
+               spectra_header,                                                                     &
+               spectra_parin
+
+    USE surface_data_output_mod,                                                                   &
+        ONLY:  surface_data_output_check_parameters,                                               &
+               surface_data_output_init_arrays,                                                    &
+               surface_data_output_parin,                                                          &
+               surface_data_output_rrd_global,                                                     &
+               surface_data_output_rrd_local,                                                      &
+               surface_data_output_wrd_global,                                                     &
+               surface_data_output_wrd_local
+
+    USE surface_mod,                                                                               &
         ONLY:  init_bc
 
-    USE synthetic_turbulence_generator_mod,                                    &
-        ONLY:  stg_parin,                                                      &
-               stg_check_parameters,                                           &
-               stg_header,                                                     &
-               stg_rrd_global,                                                 &
+    USE synthetic_turbulence_generator_mod,                                                        &
+        ONLY:  stg_check_parameters,                                                               &
+               stg_header,                                                                         &
+               stg_parin,                                                                          &
+               stg_rrd_global,                                                                     &
                stg_wrd_global
 
-    USE urban_surface_mod,                                                     &
-        ONLY:  usm_parin,                                                      &
-               usm_check_parameters,                                           &
-               usm_check_data_output,                                          &
-               usm_init_arrays,                                                &
-               usm_init,                                                       &
-               usm_swap_timelevel,                                             &
-               usm_3d_data_averaging,                                          &
-               usm_rrd_local,                                                  &
+    USE urban_surface_mod,                                                                         &
+        ONLY:  usm_3d_data_averaging,                                                              &
+               usm_check_data_output,                                                              &
+               usm_check_parameters,                                                               &
+               usm_init,                                                                           &
+               usm_init_arrays,                                                                    &
+               usm_parin,                                                                          &
+               usm_swap_timelevel,                                                                 &
+               usm_rrd_local,                                                                      &
                usm_wrd_local
 
-    USE vdi_internal_controls,                                                 &
+    USE vdi_internal_controls,                                                                     &
         ONLY:  vdi_actions
-               
-    USE virtual_measurement_mod,                                               &
-        ONLY:  vm_check_parameters,                                            &
-               vm_init,                                                        &
-               vm_init_output,                                                 &
+
+    USE virtual_measurement_mod,                                                                   &
+        ONLY:  vm_check_parameters,                                                                &
+               vm_init,                                                                            &
+               vm_init_output,                                                                     &
                vm_parin
 
-    USE wind_turbine_model_mod,                                                &
-        ONLY:  wtm_parin,                                                      &
-               wtm_check_parameters,                                           &
-               wtm_init,                                                       &
-               wtm_init_arrays,                                                &
-               wtm_init_output,                                                &
-               wtm_actions,                                                    &
-               wtm_rrd_global,                                                 &
+    USE wind_turbine_model_mod,                                                                    &
+        ONLY:  wtm_actions,                                                                        &
+               wtm_check_parameters,                                                               &
+               wtm_init,                                                                           &
+               wtm_init_arrays,                                                                    &
+               wtm_init_output,                                                                    &
+               wtm_parin,                                                                          &
+               wtm_rrd_global,                                                                     &
                wtm_wrd_global
 
-    USE user,                                                                  &
-        ONLY:  user_module_enabled,                                            &
-               user_parin,                                                     &
-               user_check_parameters,                                          &
-               user_check_data_output_ts,                                      &
-               user_check_data_output_pr,                                      &
-               user_check_data_output,                                         &
-               user_init,                                                      &
-               user_init_arrays,                                               &
-               user_header,                                                    &
-               user_actions,                                                   &
-               user_3d_data_averaging,                                         &
-               user_data_output_2d,                                            &
-               user_data_output_3d,                                            &
-               user_statistics,                                                &
-               user_rrd_global,                                                &
-               user_rrd_local,                                                 &
-               user_wrd_global,                                                &
-               user_wrd_local,                                                 &
-               user_last_actions
+    USE user,                                                                                      &
+        ONLY:  user_3d_data_averaging,                                                             &
+               user_actions,                                                                       &
+               user_check_data_output,                                                             &
+               user_check_data_output_pr,                                                          &
+               user_check_data_output_ts,                                                          &
+               user_check_parameters,                                                              &
+               user_data_output_2d,                                                                &
+               user_data_output_3d,                                                                &
+               user_header,                                                                        &
+               user_init,                                                                          &
+               user_init_arrays,                                                                   &
+               user_last_actions,                                                                  &
+               user_module_enabled,                                                                &
+               user_parin,                                                                         &
+               user_statistics,                                                                    &
+               user_rrd_global,                                                                    &
+               user_rrd_local,                                                                     &
+               user_wrd_global,                                                                    &
+               user_wrd_local
 
     IMPLICIT NONE
